      *****************************************
      * Program name: sprb.cbl
      * This web-based problem tracking system
      * program demonstrate accepting data
      * from a user input form, then creating
      * a data file record.  This program uses
      * the REPLICA clause to simplify variable
      * definitions.
      *
      * Called by:  prb.cbl
      * Calls: sprb.cbl
      *
      * Programs in this system:
      * prb.cbl, sprb.cbl, vprb.cbl, eprb.cbl
      *
      * This program calls itself from the html
      * form that it displays.  See the ACTION
      * attribute of the FORM tag in the 
      * web_body_html variable to see this.
      * 
      * Copyright 2000 Deskware, Inc.
      *****************************************
       1 prbfile PIC X(n) VALUE `PRB.TXT`.
       1 bytes_length PIC 9(4) VALUE 1116.

       FD prbfile RECORD IS bytes_length BYTES.  
      *
      * Record layout for prbfile; these variables
      * will be recalled as REPLICAs in html variables below;
      * see CobolScript manual for explanation of REPLICA.
       1 request_record.
        5 report_date     PIC X(8).
        5 email           PIC X(50).
        5 product         PIC X(50).
        5 problem         PIC X(500).
        5 resolution_date PIC X(8) VALUE `OPEN`.
        5 resolution      PIC X(500).

       1 error PIC 9 VALUE 0.
       1 content_length PIC 9(4) VALUE 0.


       1 web_header_html.
         5 `Content-type: text/html`.
         5 ` `.
         5 `<HTML><BODY>`.
         5 `<BR><BR>`.
         5 `<CENTER><FONT SIZE=4><B>Create a Problem Tracking Report</B></FONT></CENTER>`.
         5 `<HR><BR>`.
         5 `Please fill out this form to report an issue that you have encountered with `.
         5 `one of our products. &nbsp;After you complete the form, click on the <B>Create PTR</B> button. `.
         5 `&nbsp; Someone will follow up with your issue and a resolution will be posted to your problem ticket.<BR><BR>`.
         5 `For more information on PTRs, see the <A HREF="cobolscript.exe?prb.cbl">PTR Home Page</A> `.

       1 error_header_html.
         5 `Content-type: text/html`.
         5 ` `.
         5 `<HTML><BODY>`.
         5 `<BR><BR><BR><BR>`.
         5 `<CENTER><FONT SIZE=4><B>An error has occured while processing your request.</B></FONT></CENTER>`.
         5 `<HR><BR>`.
         5 `You must enter a valid <B>email address</B>.<BR>`.
         5 `For more information on PTRs, see the <A HREF="cobolscript.exe?prb.cbl">PTR Home Page</A> `.
         5 `<BR><BR>`.


       1 thank_you_header_html.
         5 `Content-type: text/html`.
         5 ` `.
         5 `<HTML><BODY>`.
         5 `<BR><BR><BR><BR>`.
         5 `<CENTER><FONT SIZE=4><B>Thank you for using our Problem Tracking Report system.</B></FONT></CENTER>`.
         5 `<HR><BR>`.
         5 `Your PTR regarding <B>`.
         5 product REPLICA. 
         5 `</B> has been entered into our system (see below).`.
         5 `Someone will follow up with you as soon as possible.`.
         5 `For more information on PTRs, see the <A HREF="cobolscript.exe?prb.cbl">PTR Home Page</A> `.
         5 `<BR><BR>`.

       1 thank_you_body_html. 
         5 `<TABLE BORDER=1 BGCOLOR="dddddd" CELLSPACING=0 CELLPADDING=0>`.
         5 `<TR><TD><B>Email Address:</B></TD>`.
         5 `<TD>`.
         5 email   REPLICA.
         5 `</TD></TR>`.
         5 `<TR><TD><B>Product:</B></TD>`.
         5 `<TD>`.
         5 product REPLICA.
         5 `</TD></TR>`.
         5 `<TR><TD><B>Description of Problem:</B></TD>`.
         5 `<TD>`.
         5 problem REPLICA.
         5 `</TD></TR></TABLE>`.


       1 web_body_html.
         5 `<FORM ACTION="cobolscript.exe?sprb.cbl" METHOD="POST">`.
         5 `<TABLE BORDER=0 BGCOLOR="6699cc" CELLSPACING=0 CELLPADDING=0>`.
         5 `<TR BGCOLOR="`.
         5 email_bgcolor PIC X(6) VALUE `6699cc`.
         5 `">`.
         5 `<TD>Your Email Address:</TD>`.
         5 `<TD><INPUT TYPE="TEXT" NAME="email" VALUE="`.
         5 email    REPLICA.
         5 `"></TD></TR>`.
         5 `<TR>`.
         5 `<TD>Product:</TD>`.
         5 `<TD><SELECT NAME="product">`.
         5 `<OPTION SELECTED>`.
         5 product REPLICA.
         5 `<OPTION>`.
         5 option2 PIC X(60).
         5 `<OPTION>`.
         5 option3 PIC X(60).
         5 `<OPTION>`.
         5 option4 PIC X(60).
         5 `<OPTION>`.
         5  option5 PIC X(60).
         5 `</SELECT></TD>`.
         5 `</TR>`.
         5 `<TR>`.
         5 `<TD>Description of Problem:</TD>`.
         5 `<TD><TEXTAREA NAME="problem" ROWS="5" COLS="60">`.
         5  problem  REPLICA.
         5 `</TEXTAREA></TD>`.
         5 `</TR>`.
         5 `<TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>`.
         5 `<TR>`.
         5 `<TD>&nbsp;</TD><TD><INPUT TYPE="Submit" VALUE="Create PTR"><INPUT TYPE="Reset" VALUE="Reset Form"></TD>`.
         5 `</FORM>`.
         5 `</TR></TABLE>`.

       1 web_footer_html. 
        5 `<BR><HR><CENTER><FONT SIZE=-1>This program copyright &copy; 2000, Deskware, Inc.</CENTER></BODY></HTML>`.


       MAIN.
           GETENV USING `CONTENT_LENGTH` content_length.
 
           IF content_length = 0
              MOVE `CS for Windows`    TO product
              MOVE `CS for SunOS`      TO option2
              MOVE `CS for Linux`      TO option3
              MOVE `CS for FreeBSD`    TO option4
              MOVE `Web Site`          TO option5
              MOVE `&#010;&#013;&#010;&#013;&#010;&#013;&#010;&#013;&#010;&#013;` TO problem
              DISPLAYLF web_header_html
              DISPLAY web_body_html
              DISPLAY web_footer_html
           ELSE
              ACCEPT DATA FROM WEBPAGE
              PERFORM PROCESS-WEB-PAGE
           END-IF.
           GOBACK. 

      *******************************************************
       PROCESS-WEB-PAGE.

           IF email = SPACES
              PERFORM CREATE-DROPDOWN-LIST
              DISPLAYLF error_header_html
              MOVE `990000`  TO email_bgcolor
              DISPLAY web_body_html
              DISPLAY web_footer_html
           ELSE
              OPEN prbfile FOR APPENDING
              ACCEPT report_date FROM DATE
              WRITE request_record TO prbfile
              CLOSE prbfile

              DISPLAYLF thank_you_header_html
              DISPLAY thank_you_body_html
              DISPLAY web_footer_html
           END-IF.


      ***********************************************************
      * Here, we re-sort our dropdown list depending on what
      * product the client selected on the page before this error.
      ************************************************************
       CREATE-DROPDOWN-LIST.
      *    Windows case
           IF product(8:3) = `Win`
              MOVE `CS for SunOS`      TO option2
              MOVE `CS for Linux`      TO option3
              MOVE `CS for FreeBSD`    TO option4
              MOVE `Web Site`          TO option5
      *    SunOS case
           ELSIF product(8:3) = `Sun`
              MOVE `CS for Windows`    TO option2
              MOVE `CS for Linux`      TO option3
              MOVE `CS for FreeBSD`    TO option4
              MOVE `Deskware Web Site` TO option5
      *    Linux case
           ELSIF product(8:3) = `Lin`
              MOVE `CS for Windows`    TO option2
              MOVE `CS for SunOS`      TO option3
              MOVE `CS for FreeBSD`    TO option4
              MOVE `Web Site`          TO option5
      *    FreeBSD case 
           ELSIF product(8:4) = `Free`
              MOVE `CS for Windows`    TO option2
              MOVE `CS for Linux`      TO option3
              MOVE `CS for SunOS`      TO option4
              MOVE `Web Site`          TO option5
      *    Web site case
           ELSIF product(1:3) = `Web`
              MOVE `CS for Windows`    TO option2
              MOVE `CS for Linux`      TO option3
              MOVE `CS for SunOS`      TO option4
              MOVE `CS for FreeBSD`    TO option5
           ELSE
              MOVE `CS for Windows`    TO product
              MOVE `CS for SunOS`      TO option2
              MOVE `CS for Linux`      TO option3
              MOVE `CS for FreeBSD`    TO option4
              MOVE `Web Site`          TO option5
           END-IF.


